#ifndef _SIOCTL_H
#define _SIOCTL_H

				/* The following structure is used */
				/* to send scsi-commands */
typedef struct {
  short device;			/* (device&0xf)        == SCSI UNIT */
				/* (device&0xf00)>>8   == LUN */
  short cmdlen;			/* # bytes in command block */
  unsigned char cmdblk[12];	/* The actual scsi command */
  long transferlen;		/* The amount to read/write */
  char *buf;			/* Buffer for io or NULL for SSCMD */
  short status;			/* Statusbyte for command */
  long  timeout;		/* Timeout for read/write command */
} SCSI_COMMAND;

/* The following #defines are preliminary, and will most certainly change */

#define SSCMD     (('S'<<8) | 0) /* Simple scsi command (no io) */
#define SRCMD	  (('S'<<8) | 1) /* Reading scsi command */
#define SWCMD     (('S'<<8) | 2) /* Writing scsi command */
#define SSLEEP	  (('S'<<8) | 3) /* Sleeptime between scsi commands */

#define TAPEMAGIC 0xec1994ce	/* Tape magic value - verify presence */

#define TMAGIC    (('t'<<8) | 0) /* Return magic value - TAPEMAGIC */
#define TMOUNT	  (('t'<<8) | 1) /* Tape mount */
#define TUMOUNT   (('t'<<8) | 2) /* Tape unmount */
#define TREW	  (('t'<<8) | 3) /* Tape rewind */
#define TWFILEM	  (('t'<<8) | 4) /* Tape write filemark, arg n filemarks */
#define TSFILEM   (('t'<<8) | 5) /* Tape skip filemark, arg n filemarks */
#define TOPTIONS  (('t'<<8) |16) /* Tapedev write options,arg struct options */

#define ESELECT		-1	/* Error during select phase */
#define EBUSY		-2	/* Error SCSI bus busy from last time */
#define EPOLL		-3	/* Timeout during polling "DMA-DONE" */
#define EACC		-4	/* Timeout while acknowledging data-byte */
#define EREQ		-5	/* Timeout while waiting for request */
#define EPWRITE		-6	/* Error during programmed write */
#define ECMD		-7	/* Error during command phase */
#define EFLOCK		-8	/* Timeout while waiting for flock semaphore */
#define EBUS		-9	/* Bus Error in DMA routine */
#endif /* _SIOCTL_H */
