#include "ttconst.h"

short_timeout		= 101		| > 0.5 sec
long_timeout 		= 201		| >   1 sec
extra_long_timeout 	= 1001		| >   5 sec
#define timer 0x4ba:w

_status_timeout:	.long	long_timeout
_sleeptime:		.word	0	| How long should we sleep between
					| commands ? Must be set externally
transferlength:		.long	0
_poll_timeout:		.long   200

		.globl	_status_timeout
		.globl  _poll_timeout
		.globl	_do_scsi
		.globl	_do_scsi32
		.globl	_sleeptime

	.even
	.text

_do_scsi32:	|(long device, long ncmd, long nbytes, long read,
		| char *cmdbuf, char *dmabuf)

	movel	sp, d3
	moveml	d1-d7/a0-a6,sp@-

	movel	d3,a0
	movel	a0@(4),d0	| device 		short
	movel	a0@(8),d2	| ncmd			short
	movel	a0@(12),d1	| nbytes		long
	movel	a0@(16),d3	| read/write		short
	movel	a0@(20),a1	| Command buffer	long
	movel	a0@(24),a2	| Dma buffer		long
	bras	got_regs

_do_scsi:	|(short device, short ncmd, long nbytes,short read,
		| char *cmdbuf, char *dmabuf)
	movel	sp, d3
	moveml	d1-d7/a0-a6,sp@-

	movel	d3,a0
	movew	a0@(4),d0	| device 		short
	movew	a0@(6),d2	| ncmd			short
	movel	a0@(8),d1	| nbytes		long
	movew	a0@(12),d3	| read/write		short
	movel	a0@(14),a1	| Command buffer	long
	movel	a0@(18),a2	| Dma buffer		long
got_regs:
	andib	#1,d3
	movel	d1,transferlength
	movel	#tt_data,a5
	movel	#tt_dmabas,a6

	tstl	d1		| Are we transferring anything ?
	bnes	do_real_command | Yes
	bsrs	simple_command
	bras	restore_regs
do_real_command:
	bsrs	scsi_command
restore_regs:
	moveml	sp@+,d1-d7/a0-a6
	rts


simple_command:
	bsrs	send_block
	bmis	exit_simple
	bsr	get_stat
exit_simple:
	bsr	_hdone
	bsr	general_cleanup
	rts

scsi_command:
	bsr	send_block
	tstl	d0
	bmis	end_scsi_command
	bsr	start_dma
	asrl	#8,d1
	asrl	#1,d1
	addl	_poll_timeout,d1
	addl	timer,d1
	bsr	wait_for_ints
	tstl	d0
	bnes	end_scsi_command
	bsr	get_stat
end_scsi_command:
	bsr	_hdone
	bsr	general_cleanup
	rts

send_block:
	movew	d0,sp@-			| Push device
	bsr	select_device
	addql	#2,sp
	tstl	d0
	bmis	end_block
	moveb	#2,a5@(tcr_off)
	moveb	#1,a5@(icr_off)
	movel	#long_timeout,d1
	addl	timer,d1
	subqw	#1,d2
nextbyte:
	bsr	write_byte
	tstl	d0
	bmis	error_block
	dbra	d2,nextbyte
	moveql	#0,d0
end_block:
	rts
error_block:
	movel	#-7,d0
	rts

select_device:
	movel	#long_timeout,d1
	addl	timer,d1
clear_again:
	btst	#6,a5@(idstat_off)
	beqs	got_busy_clear
	cmpl	timer,d1
	bhis	clear_again
	moveql	#-1,d1
	bras	exit_select
got_busy_clear:
	moveql	#0,d0
	movepl	d0,a5@(icr_off)
	movew	sp@(4),d1
	andl	#7,d1
	bset	d1,a5@(data_off)
	moveb	#1,a5@(icr_off)
	moveb	#5,a5@(icr_off)
	movel	#long_timeout,d1
	addl	timer,d1
check_busy:
	btst	#6,a5@(idstat_off)
	bnes	okbusy
	cmpl	timer,d1
	bhis	check_busy
	moveql	#-2,d1
	bras	exit_select
okbusy:
	moveql	#0,d1
exit_select:
	moveb	#0,a5@(icr_off)
only_exit_select:
	movel	d1,d0
	rts

write_byte:
	bsrs	get_request
	bmis	error_write_byte
	moveb	a1@+,a5@(data_off)
	bsrs	do_acknowledge
	rts
error_write_byte:
	moveql	#-6,d0
	rts

get_request:
	btst	#5,a5@(idstat_off)
	bnes	exit_request
	cmpl	timer,d1
	bhis	get_request
error_request:
	bsr	reset_scsi
	moveql	#-5,d0
	rts
exit_request:
	moveql	#0,d0
	rts

do_acknowledge:
	moveb	a5@(icr_off),d0
	orib	#0x11,d0
	moveb	d0,a5@(icr_off)
req_loop:
	btst	#5,a5@(idstat_off)
	beqs	req_clear
	cmpl	timer,d1
	bhis	req_loop
	movel	#-4,sp@-
	bras	ack_end
req_clear:
	clrl	sp@-
ack_end:
	bclr	#4,a5@(icr_off)
	movel	sp@+,d0
	rts

start_dma:
	movel	a2,d0			| Set DMA Start address
	movepl	d0,a6@(0)
	movepl	d1,a6@(count_off)	| Set DMA byte counter
	btst	#0,d3
	beqs 	reading
writing:
	moveb	#0,a5@(tcr_off)
	tstb	a5@(inircv_off)
	moveb	#2,a5@(mode_off)
	moveb	#1,a5@(icr_off)
	moveb	#0,a5@(dmastat_off)
	moveb	#1,a6@(control_off)
	moveb	#3,a6@(control_off)
	bras	started_it
reading:
	moveb	#0,a5@(icr_off)
	moveb	#1,a5@(tcr_off)
	tstb	a5@(inircv_off)
	moveb	#2,a5@(mode_off)
	moveb	#0,a5@(inircv_off)
	moveb	#0,a6@(control_off)
	moveb	#2,a6@(control_off)
started_it:
	moveql	#0,d0
	rts

reset_and_exit:
	bsrs	reset_scsi
	rts

wait_for_ints:
	btst	#7,GPIP_TT
	bnes	scsi_int
	btst	#5,GPIP_TT
	beqs	dma_interrupt
	cmpl	timer,d1
	bhis	wait_for_ints
	moveql	#-3,d0			| Timeout
	bras	reset_and_exit
dma_interrupt:
	btst	#7,a6@(control_off+1)
	beqs	wait_for_ints
	tstb	a5@(inircv_off)
	moveql	#-9,d0			| Bus Error
	bras	reset_and_exit
scsi_int:
	tstb	a5@(inircv_off)
	moveql	#0,d0
	moveb	d0,a6@(control_off)
	moveb	d0,a5@(mode_off)
	moveb	d0,a5@(icr_off)
	btst	#0,d3
	bnes	exit_wait_for_ints
	movepl	a6@(0),d0
	movel	d0,d1
	andiw	#3,d1
	beqs	flush_cpu
	subqw	#1,d1
	andib	#0xfc,d0
	movel	d0,a2
	movel	tt_dmarsd,d0
restloop:
	roll	#8,d0
	moveb	d0,a2@+
	dbra	d1,restloop
flush_cpu:
	movew	sr,sp@-
	oriw	#0x700,sr
	movec	cacr,d0
	oril	#0x808,d0
	movec	d0,cacr
	movew	sp@+,sr
exit_wait_for_ints:
	moveql	#0,d0
	rts

get_stat:
	movel	_status_timeout,d1
	addl	timer,d1
	moveb	#3,a5@(tcr_off)
	tstb	a5@(inircv_off)
	bsr	get_request
	bmis	error_status
	moveb	a5@(data_off),d3
	bsr	do_acknowledge
	tstl	d0
	bnes	error_status	
	movel	#long_timeout,d1
	addl	timer,d1
	bsr	get_request
	bmis	error_status
	tstb	a5@(data_off)
	bsr	do_acknowledge
	tstl	d0
	bmis	error_status
	moveb	d3,d0
error_status:
	rts

reset_scsi:
	moveb	#0x80,a5@(icr_off)
	movel	#short_timeout,d1
	addl	timer,d1
waitsomemore:
	cmpl	timer,d1
	bhis	waitsomemore
	moveb	#0,a5@(icr_off)
	movel	#extra_long_timeout,d1
	addl	timer,d1
waitevenmore:
	cmpl	timer,d1
	bhis	waitevenmore
	rts

_hdone:
	tstb	a5@(inircv_off)
	moveb	#TT_DMA_DISABLE,a6@(control_off)
	rts
general_cleanup:
	rts
